
CoCoA-5 - Bug #1397

Crashes if CoCoAHelp.xml is missing

21 Jan 2020 15:33 - John Abbott

Status: Closed Start date: 21 Jan 2020

Priority: Normal Due date:  

Assignee: Anna Maria Bigatti % Done: 100%

Category: bug Estimated time: 0.00 hour

Target version: CoCoA-5.4.0 Spent time: 1.70 hour

Description

If I make a manual query when the file CoCoAHelp.xml is not found where expected, an UNCAUGHT CoCoA ERROR happens, and

the interpreter exits (crashes).

It would be better if it did not exit.

Related issues:

Related to CoCoA-5 - Design #1631: Use filesystem::path instead of string (pa... New 12 Nov 2021

Related to CoCoA-5 - Design #1504: OnlineHelp: XMLFileName Closed 08 Oct 2020

History

#1 - 22 Jan 2020 10:03 - Anna Maria Bigatti

ouch!

it should never happen, really.

But it is bad.  I'll fixi it.

#2 - 22 Jan 2020 10:07 - Anna Maria Bigatti

I see that this give error with no crash (loading extra manuals).  This was what worried me most.

ReloadMan(["aksjf"]);

#3 - 22 Jan 2020 10:46 - Anna Maria Bigatti

- Status changed from New to In Progress

- Assignee set to Anna Maria Bigatti

- % Done changed from 0 to 20

The problem is in the constructor (I think)

  index::index()

  {

    std::ostringstream os; // does not print

    myLoad(os);

  }

If myLoad fails, then UniqueIndex does not exist.

I guess this has to be fixed separating creation and initialization, but this is a very pervasive change.    

hmmm, not today :-(
#4 - 13 Feb 2020 15:34 - John Abbott

- Target version changed from CoCoA-5.3.0 to CoCoA-5.4.0

#5 - 04 Nov 2021 23:21 - John Abbott

If CoCoAHelp.xml is missing then the installation is broken (or there is a wrong path).

Crashing/aborting may be a reasonable action in these circumstances (who know what else is broken).

There should nevertheless be a helpful message printed on std::cerr before crashing.

#6 - 04 Nov 2021 23:24 - John Abbott

- Status changed from In Progress to Resolved

- % Done changed from 20 to 80

I have just tried, and CoCoA-5 no longer crashes.  It also produced a fairly reasonable error message.

Maybe the error message could be improved (made more comprehensible to non-expert users).

#7 - 10 Nov 2021 18:27 - John Abbott

I have modified the error message slightly.  Now it gives:

/**/ ?abc

--> ERROR: CoCoA-5 manual missing (or not readable); it should be in /home/jabbott/Work/CoCoALib-0.99/src/CoCo

A-5/packages/../CoCoAManual/CoCoAHelp.xml

--> [CoCoALib] OnlineHelp::OpenXMLManual()

--> ?abc

--> ^^^^

 

I think this may be more comprehensible.  Anna, what do you think?

#8 - 10 Nov 2021 18:29 - John Abbott

It would be nice (& cleaner) if we could get rid of packages/../.

I think this should be possible.

#9 - 10 Nov 2021 18:43 - John Abbott

There is a stackoverflow thread about getting dirname: https://stackoverflow.com/questions/3071665/getting-a-directory-name-from-a-filename

Apparently in C++17 one do something like the following:

#include <iostream>

#include <filesystem>

namespace fs = std::filesystem;

int main()

{

    for(fs::path p : {"/var/tmp/example.txt", "/", "/var/tmp/."})

        std::cout << "The parent path of " << p
                  << " is " << p.parent_path() << '\n';

}

Of course, we're using C++14. But BOOST offers something similar...

According to the same stackoverflow thread, with BOOST one can do the following:

boost::filesystem::path p("C:\\folder\\foo.txt");

boost::filesystem::path dir = p.parent_path();

#10 - 10 Nov 2021 18:57 - John Abbott

We probably need to change the fn CoCoAManFileName (around line 950 in OnlineHelp.C).

The return type should be a "path" (initially boost::filesystem::path)

const boost::filesystem::path& CoCoAManFileName()

{

  static const boost::filesystem::path UniqueCopy(boost::filesystem::path(packageDir).parent_path() / "CoCoAMa

nual/CoCoAHelp.xml");

  return UniqueCopy;

}

 

NOTE should we also change the (global) variable packageDir so that it has type boost::filesystem::path?   Probably!

#11 - 12 Nov 2021 10:21 - John Abbott

- Related to Design #1631: Use filesystem::path instead of string (packageDir, CoCoAManFileName) added

#12 - 12 Nov 2021 10:23 - Anna Maria Bigatti

- Status changed from Resolved to Closed

- % Done changed from 80 to 100

No longer crashes.  So that's good.

Now we just need to clean up the path, but that's in a new issue #1631

#13 - 23 Feb 2022 11:50 - Anna Maria Bigatti

- Related to Design #1504: OnlineHelp: XMLFileName added
